//+------------+-----------------------------------------------------+
//| v.16.08.08 |                            ImposingCandleSticks.mq4 |
//|            |              Bookkeeper, 2008, yuzefovich@gmail.com |
//+------------+-----------------------------------------------------+
// imposing -     :
// , , , , ,..
//     .
/*-------------------------------------------------------------------+
   
    ,     :)
   
       ,  ,    
    :
   1.  :
   1.1.          
     Forex (    ).
   1.2.       
            (
      )     Forex (
      ).
   1.3.  (   )    
        ,   
       .
   2.   :
   2.1.          
     ,  ,    1.1
    1.2.
   2.2.  (        ex4-)
          (     ).
   
    :)   !      !
         -   ,  .
            
   ,    ,    .

                                                        Bookkeeper

  +-----------------------------------------------------------------*/
#property copyright ""
#property link      ""
//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Blue
#property indicator_color2  Blue
#property indicator_color3  Red
#property indicator_color4  Green
//----
extern int SnakeRange =15;        //  =5 !    
//----                                      
double SnakeHigh[];
double SnakeLow[];
double SnakeOpen[];
double SnakeClose[];

int init()
{
   SetIndexBuffer    (0,SnakeHigh);
   SetIndexBuffer    (1,SnakeLow);
   SetIndexBuffer    (2,SnakeOpen);
   SetIndexBuffer    (3,SnakeClose);
   SetIndexStyle     (0,DRAW_HISTOGRAM);
   SetIndexStyle     (1,DRAW_HISTOGRAM);
   SetIndexStyle     (2,DRAW_HISTOGRAM,EMPTY,3);
   SetIndexStyle     (3,DRAW_HISTOGRAM,EMPTY,3);
   return(0);
}
void deinit() { return; }
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(MathMax(SnakeRange+1,Bars-counted_bars),Bars-1);
   
   for(int i=limit;i>=0;i--)
   {
      SnakeHigh[i]=icTma(SnakeRange,High,i);
      SnakeLow[i]=icTma(SnakeRange,Low,i);
      SnakeClose[i]=icTma(SnakeRange,Close,i);
      SnakeOpen[i]=icTma(SnakeRange,Open,i);
   }
   return(0);
}

//
//
//
//
//

double icTma(int period,const double& prices[], int i)
{
   double sum  = (period+1)*prices[i];
   double sumw = (period+1);

      for(int j=1, k=period; j<period; j++,k--)
      {
         sum  += prices[i+j]*k;
         sumw += k;
         if (j<=i)
         {
               sum  += prices[i-j]*k;
               sumw += k;
         }
      }
   return(sum/sumw);
}